<?php
class BrowserCap {
	var $sUserAgent;
	var $bDisplayAccessKey;
	var $bAccessKeySupport;
	var $bIsUp;
	var $bXhtml;
	var $bWML;
	var $bHtml;
	var $bHdml;
	var $bDesktop;
	var $sOS;
	var $bXhtmlMP;
	var $bUpGui;

	function BrowserCap(){
		$bUpLink = 0;
		$bUpGui = FALSE;

	    $this->sUserAgent = $_SERVER["HTTP_USER_AGENT"];
		$this->bHdml = (is_numeric(stripos($_SERVER["HTTP_ACCEPT"], "hdml")));
		$this->bHtml = (is_numeric(stripos($_SERVER["HTTP_ACCEPT"], "html"))
			|| (is_numeric(stripos($this->sUserAgent, "*/*"))));
		$this->bXhtml = (is_numeric(stripos($_SERVER["HTTP_ACCEPT"], "xhtml")));
# To validate as xhtml uncomment this
#		$this->bXhtml = (is_numeric(stripos($_SERVER["HTTP_ACCEPT"], "xhtml"))
#			|| stristr($_SERVER["HTTP_USER_AGENT"],"W3C_Validator"));
		$this->bXhtmlMP = (is_numeric(stripos($_SERVER["HTTP_ACCEPT"], "application/vnd.wap.xhtml+xml")));
		$this->bWML = (is_numeric(stripos($_SERVER["HTTP_ACCEPT"], "wml")))
			|| strstr($this->sUserAgent, 'Opera Mini');

		#UP WAP Gateway appends html to accept header because it has an
		#WML to HTML translator which however is not very robust.
		if($this->bXhtml){
			$bUpLink = FALSE;
		}else{
			$bUpLink = (is_numeric(stripos($this->sUserAgent,"UP.Link" )));
		}
		$this->bHtml = ($this->bHtml && !$bUpLink) || (!$this->bWML && !$this->bHdml);

		$this->bIsUp = (is_numeric(stripos($this->sUserAgent,"UP.B" ))
			|| is_numeric(stripos($this->sUserAgent,"UP/")));

		if (strstr($this->sUserAgent,'Windows CE')) {
		 	$this->sOS='WinCE';
			if(stristr($this->sUserAgent, '240x320')
				|| strstr($this->sUserAgent, 'MobileExplorer')
				|| stristr($this->sUserAgent, 'Smartphone')) {
				$this->bWML = TRUE;
			}
		} else if (strstr($this->sUserAgent,'Mac')) {
			$this->sOS='Mac';
		} else if (strstr($this->sUserAgent,'Linux')) {
			$this->sOS='Linux';
		} else if (strstr($this->sUserAgent,'Unix')) {
			$this->sOS='Unix';
		} else if (strstr($this->sUserAgent,'Palm') || strstr($this->sUserAgent,'Blazer')) {
			$this->sOS='Palm';
			$this->bWML = TRUE;
		} else if (strstr($this->sUserAgent,'Win')) {
			$this->sOS='Win';
		} else {
			$this->sOS='Other';
		}

		if (($this->sOS=='Win'
		|| $this->sOS=='Mac'
		|| $this->sOS=='Unix'
		|| ($this->sOS=='Linux'
		&& !stristr($this->sUserAgent,'embedix') //Zaurus
		&& !strstr($this->sUserAgent,'MIDP'))) //Motorola Linux phones
		&& $this->bHtml == TRUE){
    		$this->bDesktop = TRUE;
		} else {
	    	$this->bDesktop = FALSE;
		}

		if ($this->bIsUp) {
			$this->bAccessKeySupport = TRUE;
			$this->bDisplayAccessKey = !$this->bXhtml;
			$this->bUpGui = is_numeric(strpos($this->sUserAgent,"(GUI)"));
		}elseif(is_numeric(strpos($this->sUserAgent,"EricssonT39"))
		  || is_numeric(strpos($this->sUserAgent,"EricssonT65"))
		  || is_numeric(strpos($this->sUserAgent,"EricssonT60"))
		  || is_numeric(strpos($this->sUserAgent,"EricssonT68"))
		  || is_numeric(strpos($this->sUserAgent,"Firefox"))
		  || is_numeric(strpos($this->sUserAgent,"EricssonR520"))){
			$this->bAccessKeySupport = TRUE;
			$this->bDisplayAccessKey = TRUE;
		}elseif($this->bXhtml || is_numeric(strpos($this->sUserAgent,"Mitsu/1.2"))) {
			$this->bAccessKeySupport = TRUE;
			$this->bDisplayAccessKey = FALSE;
		}else{
			$this->bAccessKeySupport = FALSE;
			$this->bDisplayAccessKey = FALSE;
		}
		if(stripos($_SERVER["SERVER_NAME"], "wml.yeswap") !== FALSE ){
			$this->bWML = TRUE;
			$this->bHtml = FALSE;
			$this->bXhtml = FALSE;
			$this->bXhtmlMP= FALSE;
		}elseif(stripos($_SERVER["SERVER_NAME"], "htm.yeswap") !== FALSE ){
			$this->bWML = FALSE;
			$this->bHdml = FALSE;
			$this->bHtml = TRUE;
			$this->bXhtml = FALSE;
			$this->bXhtmlMP= FALSE;
		}elseif(stripos($_SERVER["SCRIPT_NAME"], "xindex.php") !== FALSE ){
			$this->bWML = FALSE;
			$this->bHdml = FALSE;
			$this->bHtml = TRUE;
			$this->bXhtml = TRUE;
		}

		# Uncomment following line to disable wml
		#$this->bHtml = TRUE;
	}

	Function UserAgent(){
		return ($this->sUserAgent);
	}
	Function DisplayAccessKey(){
		return ($this->bDisplayAccessKey);
	}
	Function AccessKeySupport(){
		return ($this->bAccessKeySupport);
	}
	Function IsUp(){
		return ($this->bIsUp);
	}
	Function IsHdml(){
		return ($this->bHdml);
	}
	Function IsHtml(){
		return ($this->bHtml);
	}
	Function IsXhtml(){
		return ($this->bXhtml);
	}
	Function IsWML(){
		return ($this->bWML);
	}
	Function IsDesktop(){
		return ($this->bDesktop);
	}
	Function OS(){
		return ($this->sOS);
	}
	Function IsXhtmlMP(){
		return ($this->bXhtmlMP);
	}
	Function IsUpGui(){
		return ($this->bUpGui);
	}
} # end class

function stripos($haystack, $needle, $offset=0) {
	# Case insensitive strpos()
	return strpos(strtoupper($haystack), strtoupper($needle), $offset);
}
function mobPoweredby ($myDevice) {
	global $sph_messages;

	#closed <img/> to make valid xhtml
	#not all phones can handle png
	if($myDevice->IsXhtml() || $myDevice->IsHtml()){
		if (is_numeric(stripos($_SERVER["HTTP_ACCEPT"], "png"))){ ?>
			<?print $sph_messages['Powered by'];?>  <a href="http://www.cs.ioc.ee/~ando/sphider/"><img src="sphider-logo.png" style="vertical-align: middle; border: none;" alt="Sphider"/></a>
	   	<?}else{?>
			<?print $sph_messages['Powered by'];?>  <a href="http://www.cs.ioc.ee/~ando/sphider/">></a>Sphider</a>
<?		}
	}else{?>
		<?print $sph_messages['Powered by'];?>  <a href="http://wap.google.com/gwt/n?output=wml&amp;u=www.cs.ioc.ee%2F~ando%2Fsphider%2F">Sphider</a>
	<?}
}
?>